(defun rev (x)
  (if (endp x)
      nil
    (append (rev (cdr x))
            (list (car x)))))

(defun rev3 (x)
  (cond
   ((endp x)
    nil)
   ((endp (cdr x))
    (list (car x)))
   (t
    (let* ((b@c (cdr x))
           (c@rev-b (rev3 b@c))         ; note recursive call of rev3
           (rev-b (cdr c@rev-b))
           (b (rev rev-b))              ; note call of rev
           (a (car x))
           (a@b (cons a b))
           (rev-b@a (rev a@b))          ; note call of rev
           (c (car c@rev-b))
           (c@rev-b@a (cons c rev-b@a)))
      c@rev-b@a))))

(defthm append-assoc
  (equal (append (append x y) z)
         (append x (append y z))))

(defthm append-nil
  (implies (true-listp x)
           (equal (append x nil) x)))

(defthm true-listp-rev-type-prescription
  (true-listp (rev x))
  :rule-classes :type-prescription)

(defthm rev-append
  (equal (rev (append x y))
         (append (rev y) (rev x))))

(thm (equal (rev (rev 3)) nil))

(defthm rev-rev
  (implies (true-listp x)
           (equal (rev (rev x))
                  x)))

(defthm true-listp-cdr-rev
         (true-listp (cdr (rev x))))
(defthm rev-rev
         (equal (rev (rev x))
                x))

(defthm rev-is-rev3
  (equal (rev x)
         (rev3 x)))

(encapsulate
 (((triple-rev *) => *))

 (local (defun triple-rev (x)
          (rev3 x)))
 
 (defthm triple-rev-def
   (equal (triple-rev x)
          (cond
           ((endp x)
            nil)
           ((endp (cdr x))
            (list (car x)))
           (t
            (let* ((b@c (cdr x))
                   (c@rev-b (triple-rev b@c)) ; recursive call
                   (rev-b (cdr c@rev-b))
                   (b (triple-rev rev-b))     ; recursive call
                   (a (car x))
                   (a@b (cons a b))
                   (rev-b@a (triple-rev a@b)) ; recursive call
                   (c (car c@rev-b))
                   (c@rev-b@a (cons c rev-b@a)))
              c@rev-b@a))))
   :rule-classes ((:definition :clique (triple-rev)
                               :controller-alist ((triple-rev t)))))
 )

